// simple CAVE emulation

// (c) 2000 Michal Husak husakm@vscht.cz 
#ifndef __CAVE_OGL
	#define __CAVE_OGL

#ifdef WIN32
	#include<GL/glut.h> 
	#include<windows.h>   
#else
	#include "glut.h"    // Header File For The GLUT Libry
#endif
#include <stdlib.h>
#include <math.h>

// constants (key codes) the key are small (AKEY = a code)
// folowing keys are reserved for cave visualisation c,l,r,f,b
// 1,2,3,4 keys are reserved for cavebuton emulations
#define CAVE_ESCKEY 27
// key translation codes
#define CAVE_ONEKEY '1'
#define CAVE_TWOKEY '2'
#define CAVE_THREEKEY '3'
#define CAVE_FOURKEY '4'
#define CAVE_FIVEKEY '5'
#define CAVE_SIXKEY '6'
#define CAVE_SEVENKEY '7'
#define CAVE_EIGHTKEY '8'
#define CAVE_NINEKEY '9'

// abc ...
#define CAVE_AKEY 'a'
//#define CAVE_BKEY 'b'
//#define CAVE_CKEY 'c'
#define CAVE_DKEY 'd'
#define CAVE_EKEY 'e'
//#define CAVE_FKEY 'f'
#define CAVE_GKEY 'g'
#define CAVE_HKEY 'h'
#define CAVE_IKEY 'i'
#define CAVE_JKEY 'j'
#define CAVE_KKEY 'k'
//#define CAVE_LKEY 'l'
#define CAVE_MKEY 'm'
#define CAVE_NKEY 'n'
#define CAVE_OKEY 'o'
#define CAVE_PKEY 'p'
#define CAVE_QKEY 'q'
//#define CAVE_RKEY 'r'
#define CAVE_SKEY 's'
#define CAVE_TKEY 't'
#define CAVE_UKEY 'u'
#define CAVE_VKEY 'v'
#define CAVE_WKEY 'w'
#define CAVE_XKEY 'x'
#define CAVE_YKEY 'y'
#define CAVE_ZKEY 'z'

#define JOYSTIC

#ifdef JOYSTIC
// cavebutons corresponds to 1,2,3,4 numbers
 #define CAVEBUTTON1 CheckJoysticButton(JOY_BUTTON1)  
 #define CAVEBUTTON2 CheckJoysticButton(JOY_BUTTON2)  
 #define CAVEBUTTON3 CheckJoysticButton(JOY_BUTTON3)  
 #define CAVEBUTTON4 CheckJoysticButton(JOY_BUTTON4) 
 #define CAVE_JOYSTICK_X GiveJoysticValue('X')
 #define CAVE_JOYSTICK_Y GiveJoysticValue('Y')
#else
// cavebutons corresponds to 1,2,3,4 numbers
 #define CAVEBUTTON1 CAVEgetbutton(49)  
 #define CAVEBUTTON2 CAVEgetbutton(50)  
 #define CAVEBUTTON3 CAVEgetbutton(51)  
 #define CAVEBUTTON4 CAVEgetbutton(52) 
#endif

#define CAVE_LEFT_EYE 0
#define CAVE_RIGHT_EYE 1

#define CAVEEye CAVEGetEye()  

// emulate CAVEmalloc as normal malloc
#define CAVEMalloc malloc

	#ifdef __cplusplus
		extern "C" {
	#endif


void	CAVEConfigure(int* argc,char** argv,void* test);

void	CAVEInit();
	
void	CAVEInitApplication(void (*gl_init_fn)(),int i);

void	CAVEDisplay(void (*draw_fn)(), int i);
	
void	CAVEExit();

void	CAVE_PC_emu_idle(void (*idle_fn)());

int		CAVEGetEye(); 

int		CAVEgetbutton(unsigned int key);

int		CheckJoysticButton(UINT button);

float	GiveJoysticValue(char direction); 

	#ifdef __cplusplus
		}
	#endif

#endif